// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

package event;

import org.omg.CORBA.*;
import org.omg.CosEventComm.*;

class PullConsumer_impl extends _PullConsumerImplBase
{
    private PullSupplier supplier_;

    PullConsumer_impl(PullSupplier supplier)
    {
	supplier_ = supplier;
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public void
    disconnect_pull_consumer()
    {
	supplier_ = null;
    }

    int
    run()
    {
	//
	// Main loop
	//
	while(true)
	{
	    Any any = null;

	    try
	    {
		any = supplier_.pull();
	    }
	    catch(Disconnected ex)
	    {
		return 1;
	    }
	    catch(SystemException ex)
	    {
		return 1;
	    }

	    try
	    {
		String s = any.extract_string();
		System.out.println(s);
	    }
	    catch(MARSHAL ex)
	    {
	    }
	}
    }
}
