// **********************************************************************
//
// Copyright (c) 1997
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1997
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosEventChannelAdmin.impl;

import org.omg.CORBA.*;
import com.ooc.CosEventServer.*;

public class EventChannel
    extends org.omg.CosEventChannelAdmin._EventChannelImplBase
{
    //
    // The ORB
    //
    private ORB orb_;

    //
    // The consumer admin.
    //
    private ConsumerAdmin consumerAdmin_;

    //
    // The supplier admin.
    //
    private SupplierAdmin supplierAdmin_;

    public EventChannel(ORB orb)
    {
	orb_ = orb;
        consumerAdmin_ = new ConsumerAdmin(orb_, this);
        supplierAdmin_ = new SupplierAdmin(orb_, this);
	SetDefaultProperties.setDefaults();
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------
    
    public org.omg.CosEventChannelAdmin.ConsumerAdmin
    for_consumers()
    {
	return consumerAdmin_;
    }

    public org.omg.CosEventChannelAdmin.SupplierAdmin
    for_suppliers()
    {
	return supplierAdmin_;
    }

    public void
    destroy()
    {
	orb_.disconnect(this);
        
        consumerAdmin_.disconnect();
        supplierAdmin_.disconnect();
    }

    // ------------------------------------------------------------------
    // Internal functions
    // ------------------------------------------------------------------
    
    //
    // Receive event
    //
    void
    receive(com.ooc.CosEventServer.Event_impl event)
    {
	//
	// Forward event to the consumers
	//
        consumerAdmin_.receive(event);
    }
}
