// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

package test;

import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;

class TestListener_impl extends com.ooc.CosNaming._BindingListenerImplBase
{
    private int op_;
    private NamingContext ctx_;
    private NameComponent name_;
    private boolean valid_;

    TestListener_impl()
    {
	op_ = Operation.OP_NONE;
	ctx_ = null;
	valid_ = false;
    }

    void
    expect(int op, NamingContext ctx, NameComponent name)
    {
	op_ = op;
	ctx_ = ctx;
	name_ = name;
    }

    boolean
    isValid()
    {
	if(valid_)
	{
	    reset();
	    return true;
	}
	else
	    return false;
    }

    //
    // CosNaming::BindingListener operations
    //

    public void
    context_added(NamingContext ctx, NameComponent name)
    {
	validate(Operation.CONTEXT_ADDED, ctx, name);
    }

    public void
    context_removed(NamingContext ctx, NameComponent name)
    {
	validate(Operation.CONTEXT_REMOVED, ctx, name);
    }

    public void
    context_changed(NamingContext ctx, NameComponent name)
    {
	validate(Operation.CONTEXT_CHANGED, ctx, name);
    }

    public void
    object_added(NamingContext ctx, NameComponent name)
    {
	validate(Operation.OBJECT_ADDED, ctx, name);
    }

    public void
    object_removed(NamingContext ctx, NameComponent name)
    {
	validate(Operation.OBJECT_REMOVED, ctx, name);
    }

    public void
    object_changed(NamingContext ctx, NameComponent name)
    {
	validate(Operation.OBJECT_CHANGED, ctx, name);
    }

    //
    // Private functions
    //

    private void
    validate(int op, NamingContext ctx, NameComponent name)
    {
	if(op_ != op)
	    throw new RuntimeException();
	if(!ctx_._is_equivalent(ctx))
	    throw new RuntimeException();
	if(!equal(name_, name))
	    throw new RuntimeException();
	valid_ = true;
    }

    private boolean
    equal(NameComponent n1, NameComponent n2)
    {
	return(n1.id.equals(n2.id) && n1.kind.equals(n2.kind));
    }

    private void
    reset()
    {
	op_ = Operation.OP_NONE;
	valid_ = false;
    }
}
