// **********************************************************************
//
// Copyright (c) 1997
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1997
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

package org.omg.CORBA;

final public class INV_OBJREFHelper
{
    public static void
    insert(Any any, INV_OBJREF val)
    {
	any.type(type());
        write(any.create_output_stream(), val);
    }

    public static INV_OBJREF
    extract(Any any)
    {
	if(any.type().equal(type()))
	    return read(any.create_input_stream());
	else
	    throw new BAD_OPERATION();
    }

    private static TypeCode typeCode_;

    public static TypeCode
    type()
    {
        if(typeCode_ == null)
        {
            ORB orb = ORB.init();
            StructMember[] members = new StructMember[0];

            typeCode_ = orb.create_exception_tc(id(), "INV_OBJREF", members);
        }

        return typeCode_;
    }

    public static String
    id()
    {
        return "IDL:omg.org/CORBA/INV_OBJREF:1.0";
    }

    public static INV_OBJREF
    read(org.omg.CORBA.portable.InputStream in)
    {
        if(!id().equals(in.read_string()))
            throw new MARSHAL();

        INV_OBJREF val = new INV_OBJREF();
	val.minor = in.read_ulong();
	val.completed = CompletionStatus.from_int(in.read_ulong());
        return val;
    }

    public static void
    write(org.omg.CORBA.portable.OutputStream out, INV_OBJREF val)
    {
        out.write_string(id());
	out.write_ulong(val.minor);
	out.write_ulong(val.completed.value());
    }
}
